#pragma once
#include "gte_types.hpp"

namespace JabyEngine {
    namespace GTE {
        static __always_inline void ldv0(const SVECTOR& vector) {
            __asm__ volatile("lwc2 $0, 0(%0)":: "r"(&vector));
            __asm__ volatile("lwc2 $1, 4(%0)":: "r"(&vector));
        }

        static __always_inline void ldv1(const SVECTOR& vector) {
            __asm__ volatile("lwc2 $2, 0(%0)":: "r"(&vector));
            __asm__ volatile("lwc2 $3, 4(%0)":: "r"(&vector));
        }

        static __always_inline void ldv2(const SVECTOR& vector) {
            __asm__ volatile("lwc2 $4, 0(%0)":: "r"(&vector));
            __asm__ volatile("lwc2 $5, 4(%0)":: "r"(&vector));
        }
    }
}